config/routes.rb
Rails.application.routes.draw do
  get 'main/under_construction'
  get 'victimas/index'
  
  resources :tweets
  resources :monstruos
  
  root 'tweets#default'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/monstruo.rb
class Monstruo < ApplicationRecord
  has_many :tweets, dependent: :destroy
  has_many :victimas

  default_scope -> { order :nombre }
end

app/models/tweet.rb
class Tweet < ApplicationRecord
  belongs_to :monstruo

end

app/models/victima.rb
class Victima < ApplicationRecord
    belongs_to :monstruo
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/main_controller.rb
class MainController < ApplicationController
  def under_construction
  end
end

app/controllers/monstruos_controller.rb
class MonstruosController < ApplicationController
  
  def index
  end

  def show
    @monstruo = Monstruo.find(params[:id])
    if (@monstruo.tweets.count < 1)
      redirect_to monstruos_path, notice: "El monstruo no tiene tweets creados"
    end
  end

  def edit    
  end
  
  def destroy
    @eliminar = Monstruo.find(params[:id])

    if @eliminar.destroy
      redirect_to monstruos_path, notice: "El monstruo ha sido eliminado con éxito"
    else
      flash[:error] = "Hubo un error al eliminar el monstruo"
    end
  end
end

app/controllers/tweets_controller.rb
# encoding = utf-8
class TweetsController < ApplicationController
  
  def new
  	@tweet = Tweet.new
  end

  def default    
  end
  
  def index
  end

  def show
  end

  # -----------------
  # CREATE
  # El método create recibe params = { tweet: { monstruo_id: valor, estado: valor } }
  def create
    @tweet = Tweet.new(params.require(:tweet).permit(:monstruo_id, :estado))

    if @tweet.save
      redirect_to @tweet, notice: "Tweet creado con éxito"
    else
      flash[:error] = "Hubo un error al crear el tweet"
      render :new
    end
  end
end

app/controllers/victimas_controller.rb
class VictimasController < ApplicationController
  def index
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/main_helper.rb
module MainHelper
end

app/helpers/victimas_helper.rb
module VictimasHelper
end

app/views/layouts/_header.html.erb
<header>
  <div class="navbar navbar-inverse navbar-fixed-top" role="navigation">
    <div class="container">
      <div class="navbar-header">
        
        <%= link_to root_path, class: 'navbar-brand' do %>
          <%= image_tag "logo.png", title: "Logo", class: "logo" %>
        <% end %>
      </div>
      <div class="collapse navbar-collapse">
        
      </div><!--/.nav-collapse -->
    </div>

  </div>
</header>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Laboratorio4</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= render 'layouts/header' %>
    <div class="container"> 
  
      <% if flash[:notice] %>
        <div class="alert alert-info"> <%= flash[:notice] %> </div>
      <% end %>
      
      <%= yield %>
    </div>
  </body>
</html>

app/views/main/under_construction.html.erb
<div>
    <%= image_tag "en_constr.jpg", title: "En construcción", size: "450x300" %>
</div>

app/views/monstruos/edit.html.erb
<h1> Editar monstruo </h1>

<p> No está hecho </p>

app/views/monstruos/index.html.erb
<h1> Listado de Monstruos </h1>

<table class="table">

	<tr>
		<th> Nombre </th>
		<th> Descripción </th>
		<th> Critter start </th>
		<th> Acciones </th>
	</tr>

	<% monstruos = Monstruo.all %>
	<% monstruos.each do |monstruo| %>
		<tr>
			<td> <%= link_to monstruo.nombre, monstruo %> </td>
			<td> <%= monstruo.descripcion %> </td>
			<td> <%= (monstruo.critter_star) ? 'Si' : 'No' %> </td>
			<td>
				<%= link_to "Editar", edit_monstruo_path(monstruo), class: 'btn btn-info btn-sm' %>
				<%= link_to "Eliminar", monstruo, method: :delete, class: 'btn btn-danger btn-sm' %>
			</td>
		</tr>
	<% end %>

	<% if monstruos.size == 0 %>
		<tr> <td colspan="3"> No hay monstruos </td> </tr>
	<% end %>

</table>

app/views/monstruos/show.html.erb
<div>
    <h2> <%= @monstruo.nombre %> </h2>
    <p> Descripción: <%= @monstruo.descripcion %> </p>

    <h3>Tweets: </h3>

    <ul>
        <% @monstruo.tweets.each do |tweet| %>
        <li> <%= tweet.estado %> </li>
        <% end %>
    </ul>

</div>

app/views/monstruos/ver.html.erb
<!------------------------------------------------------ 
Debe mostrarse la información del primer monstruo sin
usar el id.
Se debe mostrar el nombre (como título) y la descripción 
(como párrafo).
------------------------------------------------------>

HACER <br>
/app/views/monstruos/ver.html.erb

app/views/tweets/default.html.erb
<h1> Bienvenido a Critter </h1>
<h3> ¿Qué desea hacer? </h3>
<ul>
  <li> <%= link_to "Nuevo Tweet", new_tweet_path %></li>
  <li> <%= link_to "Listado de Monstruos", monstruos_path %></li>  
  <li> <%= link_to "Listado de Victimas", victimas_index_path %></li>  
</ul>

<p> <%= link_to "Ayuda", main_under_construction_path %> </p>

app/views/tweets/index.html.erb
<!-- Listado de tweets -->

app/views/tweets/new.html.erb
<div class="container">
	<h1> Crear un tweet para un monstruo </h1>

	<%= form_for @tweet do |f| %>
		
		<div class="row">
			<div class="col-md-4">
				<%= f.label :monstruo_id, 'Monstruo' %>
  				<%= collection_select(:tweet, :monstruo_id, Monstruo.all, :id, :nombre, {}, { class: 'form-control'}) %>
  			</div>
  		</div>


		<div class="row">
			<div class="col-md-6">
				<%= f.label :estado %>
  				<%= f.text_area :estado, class: 'form-control', label: 'Estado', placeholder: 'Ingrese el estado' %>
  			</div>
  		</div>

  		<%= f.submit "Crear tweet", class: 'btn btn-primary' %>
  	</div>
<% end %>
</div>

app/views/tweets/show.html.erb
<!-- Ver un tweet -->
Detalle del tweet

app/views/victimas/index.html.erb
<h1>Listado de Victimas</h1>

<table class="table">

	<tr>
		<th> Nombre </th>
		<th> Edad </th>
		<th> Monstruo </th>
	</tr>

	<% victimas = Victima.all %>
	<% victimas.each do |victima| %>
		<tr>
			<td> <%= victima.nombre %> </td>
			<td> <%= victima.edad %> </td>
			<td> <%= link_to victima.monstruo.nombre, victima.monstruo %> </td>
		</tr>
	<% end %>

	<% if victimas.size == 0 %>
		<tr> <td colspan="3"> No hay victimas </td> </tr>
	<% end %>

</table>